﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Runtime.Serialization;

namespace Twatcher.TwitterService
{
   
    /// <summary>
    /// Model for twitter trend
    /// </summary>
    public class Trend
    {
        public string query { set; get; }

        public string name { set; get; }

        public string events { set; get; }

        public string promoted_content { set; get; }

        public string url { set; get; }
    }

    /// <summary>
    /// Model for trends results
    /// </summary>
    public class TrendsResults
    {
        /// <summary>
        /// Gets or sets the api_version.
        /// </summary>
        /// <value>The api_version.</value>
        public string api_version { get; set; }

        /// <summary>
        /// Gets or sets the as_of.
        /// </summary>
        /// <value>The as_of.</value>
        public DateTime as_of { get; set; }

        /// <summary>
        /// Gets or sets the trends.
        /// </summary>
        /// <value>The trends.</value>
        public Trend[] trends { get; set; }
    }
}
